/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.container;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Jan 11, 2005
 * @version $Id$
 */
public final class ExoContainerContext implements java.io.Serializable {

  private static ExoContainer topContainer;

  private ExoContainer container;

  public ExoContainerContext(ExoContainer container) {
     this.container = container;
  }

  public ExoContainer getContainer() {
     return container;
  }

  public static ExoContainer getTopContainer() {
    if (topContainer == null)
      topContainer = RootContainer.getInstance();
    return topContainer;
  }

  public static void setTopContainer(ExoContainer cont) {
    if (topContainer != null)
      throw new RuntimeException("Two top level containers created, but must be only one.");
    topContainer = cont;
  }
}
