/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.database.jdbc;

import java.io.IOException;
import java.io.InputStream;

import org.exoplatform.container.component.BaseComponentPlugin;
import org.exoplatform.container.configuration.ConfigurationException;
import org.exoplatform.container.xml.InitParams;
import org.exoplatform.container.xml.ValueParam;
/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: CreateDBSchemaPlugin.java 5199 2006-04-20 13:44:55Z geaz $
 */

public class CreateDBSchemaPlugin extends BaseComponentPlugin {
  
  private String dataSource;
  private String script;

  public CreateDBSchemaPlugin(InitParams params) throws ConfigurationException {
    ValueParam dsParam = params.getValueParam("data-source");
    ValueParam scriptFileParam = params.getValueParam("script-file");
    ValueParam scriptParam = params.getValueParam("script");
    
    if (dsParam != null) {
      dataSource = dsParam.getValue();
      if(scriptParam != null) {
        script = scriptParam.getValue();
      } else if(scriptFileParam != null){
        ClassLoader cl = this.getClass().getClassLoader(); //Thread.currentThread().getContextClassLoader();
        InputStream  is = cl.getResourceAsStream(scriptFileParam.getValue());
        if(is == null)
          throw new ConfigurationException("Could not open input stream for db script "+cl.getResource(scriptFileParam.getValue()));
        try {
          byte[] buf = new byte[is.available()];
          is.read(buf);
          script = new String(buf);
        } catch (IOException e) {
          e.printStackTrace();
        } finally {
          try {
            is.close();
          } catch (IOException e) {}
        }
      }
    }
  }

  public String getDataSource() {
    return dataSource;
  }

  public String getScript() {
    return script;
  }

}
