/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.templates.groovy;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Mar 2, 2005
 * @version $Id$
 * 
 * This loader is used to load a single template.  The developer can create a template at the
 * runtime base on the runtime information and register it with the GroovyTemplateService
 */
public class GroovyTemplateTextLoader extends GroovyTemplateLoader {
  final static public String LOADER_TYPE = "text" ;
  
  private String name_ ;
  private ByteArrayInputStream is_ ;
  
  public GroovyTemplateTextLoader(String name, String text) {
    name_ =name;    
    is_ = new ByteArrayInputStream(text.getBytes()) ;    
  }
  
  public boolean canLoad(String type, String template) throws Exception {    
    if(type == null || LOADER_TYPE.equals(type)) {
      return name_.equals(template) ;
    }
    return false ;
  }
  
  /**
   * Since there is  only one template in the loader and the canLoad method already check
   * if this loader can load the template or not , so  it just  return the cached InputStream
   */
  public InputStream load(String template) throws Exception {    
    return is_ ;
  }
}
