/*
 * Created on Mar 14, 2005
 */
package org.exoplatform.faces.core.renderer.html;

import java.io.IOException;
import java.util.Collection;
import java.util.Iterator;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.exoplatform.faces.core.component.UIUploadInput;

/**
 * @author benjaminmestrallet
 */
public class UploadInputRenderer extends HtmlBasicRenderer {

  public void encodeBegin(FacesContext context, UIComponent component)  throws IOException {
    ResponseWriter w = context.getResponseWriter();
    UIUploadInput uiInput = (UIUploadInput) component;
    w.write("<input name='");
    w.write(uiInput.getName());
    w.write("'");
    w.write(" type='file'");
    if (uiInput.getClazz() != null) {
      w.write(" class='");
      w.write(uiInput.getClazz());
      w.write("'");
    }
    if (!uiInput.isEditable() || uiInput.isReadonly()) {
      w.write(" readonly='readonly' ");
    }
    w.write("/>");
    if(uiInput.hasSelectors()){
      Collection selectors = uiInput.getSelectors();
      for (Iterator iter = selectors.iterator(); iter.hasNext();) {
        String button = (String) iter.next();
        w.write(button);
      }
    }    
    if (uiInput.hasError()) {
      w.write("<span style='color: red'>*</span>");
    }
  }

}