package org.exoplatform.faces.core.renderer.html;

import java.io.IOException;
import java.util.Map;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.core.component.UIWYSIWYG;

/**
 * @author franceschini
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class WYSIWYGRenderer extends HtmlBasicRenderer {
	
	public static String BASIC = "basic";
	public static String INPUT_ONLY = "input-only";
	
	public void decode(FacesContext context, UIComponent component) {
    UIWYSIWYG uiInput = (UIWYSIWYG) component;
		if(!uiInput.isEditable() || uiInput.isReadonly()) return ;
		Map paramMap = context.getExternalContext().getRequestParameterMap();
		String value = (String) paramMap.get(uiInput.getName());
		if (value == null) return  ;
		// Update managed bean (model object)		
		if (!FacesUtil.updateBoundValueBinding(context, component, "text", value)) {		
			uiInput.setText(value);
		}
	}
	
  public void encodeBegin(FacesContext context, UIComponent component) throws IOException {
    UIWYSIWYG uiHtmlArea = (UIWYSIWYG) component;
    ResponseWriter w = context.getResponseWriter() ;
    String value = uiHtmlArea.getText() ;
    String htmlType = uiHtmlArea.getHtmlType();
    
    String portalName = PortalContainer.getInstance().getPortalContainerInfo().getContainerName();
    
    if (value == null) value = "" ;
    w.write("<script type=\"text/javascript\" src=\"/"+portalName+"/FCKeditor/fckeditor.js\"></script>");
    w.write("<script>");
    w.write(" var fckeditor"+uiHtmlArea.getName()+" = new FCKeditor( '"+uiHtmlArea.getName()+"' ); \n") ;
    String basePath = "/" + portalName + "/FCKeditor/";
    w.write(" fckeditor"+uiHtmlArea.getName()+".BasePath	= '" + basePath + "' ; \n");
    if(htmlType != null && htmlType.equalsIgnoreCase(BASIC)){
	    w.write("	fckeditor"+uiHtmlArea.getName()+".ToolbarSet	= 'Basic' ; \n");
    }else if(htmlType != null && htmlType.equalsIgnoreCase(INPUT_ONLY)){
      	w.write("	fckeditor"+uiHtmlArea.getName()+".ToolbarSet	= 'InputOnly' ; \n");
    	  w.write("	fckeditor"+uiHtmlArea.getName()+".Height	= '50px' ; \n");
    }
    w.write("	fckeditor"+uiHtmlArea.getName()+".Value	= '");
    w.write(	value);
    w.write("' ; \n");
    w.write("	fckeditor"+uiHtmlArea.getName()+".Create(); \n");
    w.write("</script>");
  }
}
