/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.search.renderer.html;

import java.io.IOException;
import java.util.ResourceBundle;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.component.UIPageListIterator;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.faces.search.component.UISearchSummary;
import org.exoplatform.faces.search.component.model.DocumentDataHandler;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: SearchSummaryRenderer.java,v 1.3 2004/11/01 20:15:12 tuan08 Exp $
 */
public class SearchSummaryRenderer extends HtmlBasicRenderer {

  public void encodeChildren(FacesContext context, UIComponent component)  throws IOException {
    UISearchSummary uiSummary = (UISearchSummary) component;
    ResponseWriter w = context.getResponseWriter();
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext());
    UIPageListIterator uiPageIterator = uiSummary.getUIPageIterator() ;
    Parameter docIndexParam = new Parameter(UISearchSummary.DOCUMENT_INDEX, "") ;
    Parameter[] viewParams = {UISearchSummary.viewParam_, docIndexParam } ;
    DocumentDataHandler dhandler = (DocumentDataHandler)uiPageIterator.getPageListDataHandler() ;
    w.write("<div class='UISearchSummary'>") ;
    String scoreIcon = res.getString("UISearchSummary.icon.score") ;
    dhandler.begin() ;
    if(dhandler.getAvailable() == 0){
      w.write("<div class='no-results'>");
      w.  write(res.getString("UISearchSummary.label.no-result")) ;
      w.write("</div>");
    }
    while(dhandler.nextRow()) {
      docIndexParam.setValue(Integer.toString(dhandler.getCurrentRow())) ;
      w.write("<div class='title'>");
      w.write(res.getString("UISearchSummary.icon.module." + dhandler.getModule())) ;
      String title = dhandler.getTitle() ;
      if(title == null || title.length() == 0) {
        //title = res.getString("UISearchSummary.lable.no-subject");
        title = "No Subject";
      }
      linkRenderer_.render(w, uiSummary, title, viewParams);
      w.write("</div>") ; 
      w.write("<div class='description'>");
      w.  write(dhandler.getDescription()) ; 
      w.write("</div>") ; 
      w.write("<div class='score'>") ; 
      int stars = Math.round(dhandler.getScore() * 5) ;
      for(int i = 0; i < stars; i++) {
        w.write(scoreIcon) ;
      }
      w.write("</div>") ; 
    }
    dhandler.end() ;  
    w.  write("<div style='text-align: right;'>") ;
    uiPageIterator.encodeBegin(context) ;
    w.  write("</div>") ;
    w.write("</div>") ;
  }
}