/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.jvm.component;

import java.lang.management.ThreadInfo;
import java.lang.management.ThreadMXBean;
import java.util.ArrayList;
import java.util.List;

import org.exoplatform.container.RootContainer;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
/**
 * May 31, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $ID$
 **/
public class UIProcessInfo extends UIExoCommand {
  static private String   SHOW_LIST_ACTION =  "listProcessInfo" ;
  static private String   SHOW_DETAIL_ACTION = "showProcessInfo" ;
  static String LIST_VIEW = "list", DETAIL_VIEW = "detail" ;
  
  static Parameter[] SHOW_LIST_PARAMS = { new Parameter(ACTION , SHOW_LIST_ACTION )} ;
  static Parameter[] SHOW_DETAIL_PARAMS = { new Parameter(ACTION , SHOW_DETAIL_ACTION )} ;

  private String view_ = LIST_VIEW ;
  private List threadsInfo_ ;
  private ThreadInfo threadInfo_ ;
  
	public UIProcessInfo() {
		setRendererType("VelocityRenderer") ;
    addActionListener(ShowThreadInfoActionListener.class, SHOW_DETAIL_ACTION) ;
    addActionListener(ListThreadInfoActionListener.class, SHOW_LIST_ACTION) ;
    updateThreadList() ;
    
	}
	
	public Parameter[]  getShowListParams() { return SHOW_LIST_PARAMS ; }
  public Parameter[]  getShowDetailParams() { return SHOW_DETAIL_PARAMS ; }
  
	public String getView() { return view_ ; }
	
  public List getThreadsInfo() { return threadsInfo_ ; }
  
  public ThreadInfo getThreadInfo() { return threadInfo_ ; }
  
	void  updateThreadList() {
	  ThreadMXBean threadMXBean = (ThreadMXBean)RootContainer.getComponent(ThreadMXBean.class) ;
	  Object[] array = threadMXBean.getThreadInfo(threadMXBean.getAllThreadIds()) ;
	  threadsInfo_ = new ArrayList() ;
	  for(int i = 0; i < array.length; i++) {
	    threadsInfo_.add(array[i]) ;
	  }
	}
  
	static public class ShowThreadInfoActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIProcessInfo uicomp = (UIProcessInfo) event.getComponent() ;
      String id = event.getParameter(OBJECTID) ;
      long threadId = Long.parseLong(id) ;
      ThreadMXBean threadMXBean = (ThreadMXBean)RootContainer.getComponent(ThreadMXBean.class) ;
      uicomp.threadInfo_ = threadMXBean.getThreadInfo(threadId) ;
      uicomp.view_ = DETAIL_VIEW  ;
    }
  }
  
  static public class ListThreadInfoActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIProcessInfo uicomp = (UIProcessInfo) event.getComponent() ;
      uicomp.updateThreadList() ;
      uicomp.view_ = LIST_VIEW ;
    }
  }
}