/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.monitor.component;

import java.util.* ;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UIDateTimeInput;
import org.exoplatform.faces.core.component.UINode;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.model.SelectItem ;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;

/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UISearchForm.java,v 1.4 2004/09/29 17:44:51 benjmestrallet Exp $
 */
public class UIPortalActionFilter extends UISimpleForm {
  static String TYPE =  "type" , COMPONENT_ID = "componentId",HITS = "hits", 
                        FROM_DATE_TIME = "fromDateTime", TO_DATE_TIME = "toDateTime" ;

  public UIPortalActionFilter() {
    super("filterForm", "post", null) ;
    setId("UIPortalActionFilter");
    setClazz("UISimpleForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    GregorianCalendar calendar = new GregorianCalendar() ;
    calendar.set(GregorianCalendar.HOUR_OF_DAY, 0) ;
    calendar.set(GregorianCalendar.MINUTE, 0) ;
    calendar.set(GregorianCalendar.SECOND, 0) ;
    calendar.set(GregorianCalendar.MILLISECOND, 0) ;
    add(new UIDateTimeInput(FROM_DATE_TIME,calendar.getTime())) ;
    calendar.set(GregorianCalendar.HOUR_OF_DAY, 24) ;
    add(new UIDateTimeInput(TO_DATE_TIME,calendar.getTime())) ;
    add(new UIStringInput(COMPONENT_ID, "")) ;
    List<SelectItem> list = new ArrayList<SelectItem>() ;
    list.add(new SelectItem("Portal", "portal")) ;
    list.add(new SelectItem("Page", "page")) ;
    list.add(new SelectItem("Portlet", "portlet")) ;
    add(new UISelectBox(TYPE, "", list)) ;
    List<SelectItem> counterList = new ArrayList<SelectItem>() ;
    counterList.add(new SelectItem(" > 0 ", "0")) ;
    counterList.add(new SelectItem(" > 10 ", "10")) ;
    counterList.add(new SelectItem(" > 100", "100")) ;
    counterList.add(new SelectItem(" > 1000", "1000")) ;
    add(new UISelectBox(HITS, "0", counterList)) ;
    addActionListener(UpdateActionListener.class, UPDATE_ACTION) ;
  }
  
  public String getUpdateAction() { return UPDATE_ACTION ; }
  
  static public class UpdateActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception { 
		  UIPortalActionFilter uiForm = (UIPortalActionFilter) event.getSource() ;
      String type = uiForm.getUISelectBox(TYPE).getValue() ;
      String componentId = uiForm.getUIStringInput(COMPONENT_ID).getValue() ;
      if(type == null || type.length() == 0) type = null ;
      if(componentId == null || componentId.length() == 0) componentId = "" ;
      String hits = uiForm.getUISelectBox(HITS).getValue() ;
      Date fromDateTime = uiForm.getUIDateTimeInput(FROM_DATE_TIME).getCalendar().getTime() ;
      Date toDateTime = uiForm.getUIDateTimeInput(TO_DATE_TIME).getCalendar().getTime() ;   
      String mostAccess = "" ;
      Object obj = uiForm.getParent() ;
      if (obj.getClass().equals(UIStatisticsPortalActionLog.class)){
        UIStatisticsPortalActionLog uiStatistics = (UIStatisticsPortalActionLog) uiForm.getParent() ;
        uiStatistics.update(type, componentId, fromDateTime, toDateTime, Long.parseLong(hits), mostAccess) ;
      }else {
        UINode uiMonitor  = (UINode)uiForm.getParent().getParent();
        UIStatisticsPortalActionLog uiStatistics = (UIStatisticsPortalActionLog) uiMonitor.getChildComponentOfType(UIStatisticsPortalActionLog.class) ; //uiForm.getParent() ;
        uiStatistics.update(type, componentId, fromDateTime, toDateTime, Long.parseLong(hits), mostAccess) ;
        UIPortalActivitiesLogChart uiPortalChart = (UIPortalActivitiesLogChart)uiStatistics.getSibling(UIPortalActivitiesLogChart.class) ;
        uiStatistics.setRenderedSibling(UIPortalActivitiesLogChart.class) ;
        List logList = uiStatistics.getChartData(uiStatistics.getSelectType());
        uiPortalChart.updatePortalLogDataSet(logList, uiStatistics.getSelectType(), mostAccess) ;  
      }
      
		}	
  }
}