package org.esupportail.cas.server.handlers.nt;

import org.dom4j.Element;
import org.esupportail.cas.server.util.RedundantHandler;

/**
 * This class implements a Windows NT handler class.
 *
 * @author Todd Runstein <todd.runstein at yahoo.com>
 */
public final class NtHandler extends RedundantHandler {
	
	/**
	 * The NT domain to bind to.
	 */
	private String domain;
	
	/**
	 * Constructor.
	 *
	 * @param handlerElement the XML element that declares the handler 
	 * in the configuration file
	 * @param configDebug debugging mode of the global configuration
	 * @throws Exception Exception
	 */
	public NtHandler(
			final Element handlerElement, 
			final Boolean configDebug) throws Exception {
		super(handlerElement, configDebug);
		traceBegin();

		checkConfigElement(true);
		
		domain = getConfigSubElementContent("domain", true/*needed*/);
		trace("domain = " + domain);

		// add the NtServer instances
		addServers(true/*serverElementNeeded*/, getClass().getPackage().getName() + ".NtServer");

		traceEnd();
	}

}

