/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.admin;

import condition.* ;
import suites.share.CommonUnit ;
import suites.share.UserLoginSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.share.UserLogoutSuite;
/**
 * To run This suite :
 * 
 *1) build and deploy ecm  as usual    
 *2) Then go to the link http://localhost:8080/webunit-suites/controller
 *3) Click on the "Config Test" button, change http://localhost:8080/portal to http://localhost:8080/ecm and save it
 *4) Click on the "Select Suite" button.  Should  be the last  button
 *5) Select the suite "Test Admin View Suite"
 *6) Click on the "next unit" button , just continue to click on it  to run unit by unit
 */
public class TestAdminViewSuite extends WebUnitSuite {
  static String DESC = "Go to Manager Admin page and test all basic actions" ;
  static String NAME = "TestAdminViewSuite" ;
  String COMMENT = null;   
  public TestAdminViewSuite() {    
    super(NAME, DESC) ;     
    goToPage("/Site Map/ecm") ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnProduction", "click on Production button").
        setURL("&uicomponent=UIWorkspaceBrowser&op=selectWorkspace&objectId=production").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectWorkspace"))      
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("ClickOnHome", "click on home link").
        setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users"))     
      ) ; 
      addWebUnit(
        new ClickURLLinkUnit("ClickOnUsers", "click on users link").
        setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/exoadmin"))      
      ) ;
      addWebUnit(
        new ClickURLLinkUnit("ClickOnCurrentUser", "click on current user link").
        setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/exoadmin")
      ) ;
//    Select Actions tab
      addWebUnit(
        new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
        setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
      ) ;
      //Click on Add document
      addWebUnit(
        new ClickURLLinkUnit("AddDocument", "click on Add Document button").
        setURL("&uicomponent=UIToolbar&op=addDocument").                  
        addValidator(new ExpectFormIdValidator("selectDocumentForm")).
        addValidator(new ExpectFormIdValidator("documentForm"))
      ) ;
      //----------Save New Document
      addWebUnit(
        new SubmitFormUnit("SaveNewDocument", "click on save button").
        setFormId("documentForm").   
        setField("docName","test-doc1").
        setField("summary","content").      
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=editDocument&objectId=test-doc"))
      ) ;                
      //Save session
      addWebUnit(
        new ClickURLLinkUnit("SavedSession", "click on save Session button").
        setURL("&uicomponent=MainToolbar&op=saveSession").        
        addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;
      addWebUnit(
          new ClickURLLinkUnit("AddDocument", "click on Add Document button").
          setURL("&uicomponent=UIToolbar&op=addDocument").                  
          addValidator(new ExpectFormIdValidator("selectDocumentForm")).
          addValidator(new ExpectFormIdValidator("documentForm"))
    ) ;
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("documentForm").   
      setField("docName","test-doc2").
      setField("summary","content").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=editDocument&objectId=test-doc"))
    ) ;                
    //Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickInfo", "click on save Session button").
        setURL("portal:componentId=jcr&portal:type=action&portal:isSecure=false&uicomponent=UIViewController&op=selectNode&objectId=Info").        
        addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickTest-doc1", "click on save Session button").
        setURL("?portal:componentId=jcr&portal:type=action&portal:isSecure=false&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/exoadmin/test-doc1").        
        addValidator(new ExpectLinkWithURLValidator("?portal:componentId=jcr&portal:type=action&portal:isSecure=false&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/exoadmin/test-doc1"))      
      ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickProperties", "click on save Session button").
        setURL("?portal:componentId=jcr&portal:type=action&portal:isSecure=false&uicomponent=UIToolbar&op=viewProperties").        
        addValidator(new ExpectLinkWithURLValidator("?portal:componentId=jcr&portal:type=action&portal:isSecure=false&uicomponent=UIToolbar&op=viewProperties"))      
      ) ;
    addWebUnit(
        new ClickURLLinkUnit("Gototest-doc2", "click on save Session button").
        setURL("&uicomponent=UIJCRExplorer&op=changeNode&objectId=/home/users/exoadmin").        
        addValidator(new ExpectTextValidator(""))      
      ) ;
    addWebUnit(
        new ClickURLLinkUnit("DeleteTest-doc2", "click on save Session button").
        setURL("?portal:componentId=jcr&portal:type=action&portal:isSecure=false&uicomponent=UIDocumentInfo&op=removeNode&objectId=test-doc2").        
        addValidator(new ExpectTextValidator("The node /home/users/exoadmin/test-doc2 has been removed."))      
      ) ;
    //Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator(""))      
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickTest-doc1", "click on save Session button").
        setURL("?portal:componentId=jcr&portal:type=action&portal:isSecure=false&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/exoadmin/test-doc1").        
        addValidator(new ExpectTextValidator("?portal:componentId=jcr&portal:type=action&portal:isSecure=false&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/exoadmin/test-doc1"))      
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickProperties", "click on save Session button").
        setURL("?portal:componentId=jcr&portal:type=action&portal:isSecure=false&uicomponent=UIToolbar&op=viewProperties").        
        addValidator(new ExpectTextValidator(""))      
    ) ;   
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }  
}