/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * This suite does :
 *    1) Go to home page and click on Edit Page Mode
 *    2) Add portlet content browse
 *    3) Go to home/users/current user and add a new folder
 *    4) Add a new document with type is nt:file and a new document with type is exo:article
 *    5) Go to home then test basic actions of path config and query config 
 *  
 * Created by The eXo Platform SARL
 * Author : Hoa Nguyen Thi
 *          hoa.nguyen@exoplatform.com, hoa2501@yahoo.com
 * Apr 25, 2006
 */
public class UserContentBrowseSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, click on Info tab, click on Manage Categories button and to do somethings" ;
  static String NAME = "UserContentBrowseSuite" ;
  String COMMENT  = "You must run AdminManageTaxonomySuite and AdminViewSuite and PortletRegistrySuite before run this suite";
  
  public UserContentBrowseSuite() {    
    super(NAME, DESC) ;    
    goToPage("/home");
    addWebUnit(CommonUnit.CLICK_EDIT_PAGE_MODE) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnAddPortlet", "Click on Add Portlet icon").
        setURL("portal:componentId=news&portal:action=addPortlet").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=cms-content"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOn'cms-content'category", "Expand Cms-Content category").
        setURL("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=cms-content").   
        addCondition(new NoLinkWithURLCondition("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId=cms-content/ContentBrowser")).
        addValidator(new ExpectTextValidator("ContentBrowser"))
    ) ;           
    //-----Selete a portlet in expanded content category
    addWebUnit(
        new ClickURLLinkUnit("ContentBrowser'portlet", "Select the Content Browser portlet").      
        setURL("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId=cms-content/ContentBrowser").
        addValidator(new ExpectLinkWithURLValidator("portal:componentId=news&portal:action=changeTab&objectId=ContentBrowser"))        
    ) ;
    addWebUnit( CommonUnit.CLICK_SAVE_PAGE) ;
    addWebUnit( CommonUnit.CLICK_VIEW_MODE) ;    
    addWebUnit(
        new ClickURLLinkUnit("ClickContentBrowser", "Click on ContentBrowser tab").
        setURL("portal:componentId=news&portal:action=changeTab&objectId=ContentBrowser").                
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentList&op=viewCategory&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory"))
    ) ;  
    addWebSuite(new UserAddFolderSuite());        
    //Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ;
    //Click on Add document
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectDocumentForm")).
      addValidator(new ExpectFormIdValidator("documentForm"))
    ) ;
    //-----Add new Nt:file document
    addWebUnit(
      new SubmitFormUnit("SelectDocumentType", "select document type is nt:file").
      setFormId("selectDocumentForm").   
      setField("documentType","nt:file").
      setField("op","changeDocument").
      addValidator(new ExpectNoTextValidator("Image to upload")).
      addValidator(new ExpectTextValidator("File")).
      addValidator(new ExpectTextValidator("Content:"))
    ) ;
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("documentForm").   
      setField("docName","test-doc").
      setField("summary","content").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=editDocument&objectId=/home/users/#{client.name}/test-folder/test-doc"))
    ) ;          
    //Click on Add document
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectDocumentForm")).
      addValidator(new ExpectFormIdValidator("documentForm"))
    ) ;
    //-----Add new Nt:file document
    addWebUnit(
      new SubmitFormUnit("SelectDocumentType", "select document type is nt:file").
      setFormId("selectDocumentForm").   
      setField("documentType","exo:article").
      setField("op","changeDocument").
      addValidator(new ExpectTextValidator("Image to upload"))
    ) ;
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("documentForm").   
      setField("docName","test-doc").
      setField("title","title").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=editDocument&objectId=/home/users/#{client.name}/test-folder/test-doc"))
    ) ;      
    //Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    goToPage("/home");
    addWebUnit(
        new ClickURLLinkUnit("ClickOnSearchIcon", "Click on search icon").
        setURL("uicomponent=MainToolbar&op=search").   
          addValidator(new ExpectFormIdValidator("UISearchForm"))
    ) ;
   addWebUnit(
        new SubmitFormUnit("SearchNotExistCategory", "search with not exist category").
        setFormId("UISearchForm").   
        setField("type","Category").
        setField("keyword","notExistCategory").
        setField("op","searchAction").                  
        addValidator(new ExpectTextValidator("No result"))      
    ) ;
    addWebUnit(
        new SubmitFormUnit("SearchChildCategory", "search with exist childCategory").
        setFormId("UISearchForm").   
        setField("type","Category").
        setField("keyword","childCategory").
        setField("op","searchAction").                  
        addValidator(new ExpectTextValidator("childCategory")).      
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIResults&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnPathchildCategory", "Click on path of searched childCategory").
        setURL("uicomponent=UIResults&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory").                  
        addValidator(new ExpectTextValidator("childCategory"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnSearchIcon", "Click on search icon").
        setURL("uicomponent=MainToolbar&op=search").                  
        addValidator(new ExpectFormIdValidator("UISearchForm"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("PathConfig"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnPathConfigTab", "Click on 'Path config' button").
        setURL("uicomponent=null&op=selectNode&objectId=UIPathConfigTab").                  
        addValidator(new ExpectFormIdValidator("PathConfig"))
    ) ;   
    addWebUnit(
        new SubmitFormUnit("SelectUsecaseType", "click on save button").
        setFormId("PathConfig").   
        setField("usecase","Document").
        setField("op","changeUsecase").
        addValidator(new ExpectTextValidator("documentName"))
    ) ;     
    COMMENT = "Because don't set field 'path' ";
    addWebUnit(
      new TODO("Can'tPathConfig", COMMENT).
      setComment(COMMENT).
      setStatus(WebUnit.STATUS_INCOMPLETE)
    ) ;
//    addWebUnit(
//        new SubmitFormUnit("SubmitPathConfig", "Submit Path config").
//        setFormId("PathConfig").   
//        setField("usecase","Document").
//        setField("path","/home/users/#{client.name}/test-folder").        
//        setField("documentName","test-doc").
//        setField("op","save").
//        addValidator(new ExpectTextValidator("Save successfully"))
//    ) ;
    addWebUnit(
        new SubmitFormUnit("ReSelectUsecaseType", "click on save button").
        setFormId("PathConfig").   
        setField("usecase","JCRPath").
        setField("op","changeUsecase").
        addValidator(new ExpectTextValidator("Reference Document"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnQueryConfigTab", "Click on 'Query config' button").
        setURL("&uicomponent=null&op=selectNode&objectId=UIQueryConfigTab").                  
        addValidator(new ExpectFormIdValidator("QueryConfig"))
    ) ;  
    COMMENT = "Because don't set field 'Query'";
    addWebUnit(
      new TODO("Can'tQueryConfig", COMMENT).
      setComment(COMMENT).
      setStatus(WebUnit.STATUS_INCOMPLETE)
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on view icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectTextValidator("Category "))
    ) ;    
//    addWebUnit(
//        new ClickURLLinkUnit("ClickOnSearchIcon", "Click on search icon").
//        setURL("&uicomponent=MainToolbar&op=search").                  
//        addValidator(new ExpectFormIdValidator("UISearchForm"))
//    ) ;
//    addWebUnit(
//        new SubmitFormUnit("Searchtest-docContent", "search with exist content test-doc").
//        setFormId("UISearchForm").   
//        setField("type","Content").
//        setField("keyword","content").
//        setField("op","searchAction").                  
//        addValidator(new ExpectTextValidator("test-doc")).      
//        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIResults&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory"))
//    ) ;
    addWebUnit(
        new ClickLinkWithText("ClickOnECM", "Go to ECM").
        setTextLink("ECM").
        addValidator(new ExpectTextValidator("test-doc"))
    ) ; 
    addWebUnit(
      new ClickURLLinkUnit("Deletetest-doc", "Delete test-doc of nt:file").
      setURL("uicomponent=UIDocumentInfo&op=removeNode&objectId=/home/users/#{client.name}/test-folder/test-doc").                  
      addValidator(new ExpectTextValidator("The node /home/users/#{client.name}/test-folder/test-doc has been removed."))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("Deletetest-doc", "Delete test-doc of exo:article").
        setURL("uicomponent=UIDocumentInfo&op=removeNode&objectId=/home/users/#{client.name}/test-folder/test-doc").      
        addValidator(new ExpectTextValidator("The node /home/users/#{client.name}/test-folder/test-doc has been removed."))
    ) ;
    //Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    //Return to workspace selection
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;    
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}