/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserUploadSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, click on upload and to do somethings" ;
  static String NAME = "UserUploadSuite" ;
  String COMMENT = null;
  
  public UserUploadSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());   
    //Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ;
    //-----Upload a file to created Folder
    addWebUnit(
      new ClickURLLinkUnit("UploadFileToFolder", "click on Upload button").
      setURL("&uicomponent=UIToolbar&op=upload").                  
      addValidator(new ExpectFormIdValidator("uploadForm"))      
    ) ;
    //----------Save File
    def is;
    is= Thread.currentThread().
        getContextClassLoader().
        getResourceAsStream("org/exoplatform/test/web/Util.class") ;    
    
    addWebUnit(
      new SubmitFormUnit("SaveFile", "click on save button").
      setFormId("uploadForm").   
      setFileField("upload","Unit.class", is).
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/#{client.name}/test-folder/upload")).
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIDocumentInfo&op=editDocument&objectId=/home/users/#{client.name}/test-folder/upload"))
    ) ;
    //-----Reupload the same file and check version
    addWebUnit(
      new ClickURLLinkUnit("ReuploadFileToFolder", "click on Upload button").
      setURL("&uicomponent=UIToolbar&op=upload").                  
      addValidator(new ExpectFormIdValidator("uploadForm"))      
    ) ;
    //----------Save File
    is = Thread.currentThread().
        getContextClassLoader().
        getResourceAsStream("org/exoplatform/test/web/Util.class") ;    
    
    addWebUnit(
      new SubmitFormUnit("SaveFile", "click on save button").
      setFormId("uploadForm").   
      setFileField("upload","Unit.class", is).
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/#{client.name}/test-folder/upload")).
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIDocumentInfo&op=checkout&objectId=/home/users/#{client.name}/test-folder/upload"))
    ) ;
    //-----Check out upload file
    addWebUnit(
      new ClickURLLinkUnit("CheckoutUploadFile", "click on check out button").
      setURL("uicomponent=UIDocumentInfo&op=checkout&objectId=/home/users/#{client.name}/test-folder/upload").                  
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIDocumentInfo&op=checkin&objectId=/home/users/#{client.name}/test-folder/upload"))
    ) ;    
    //Saved Session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;    
    //Select Workspace
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;    
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}