/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.web;

import condition.* ;
import suites.share.*;
import suites.share.UserLoginSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Nov 14, 2005
 * @author: Dung Hoang
 * @email:   dunghoang@exoplatform.com
 **/
static public class CheckAllLinkSuite extends WebUnitSuite {
  static String DESC = "Go to SiteMap page and link to all other page" ;
  static String NAME = "CheckAllLinkSuite" ;
  public CheckAllLinkSuite() {    
    super(NAME, DESC) ;
    init("/Site Map") ;
  }  
  public CheckAllLinkSuite(String path) {
    super(NAME, DESC) ;
    init(path) ;
  }  
  public void  init(path) {
    goToPage(path) ;
    addWebUnit(
        new ClickLinkWithText("User Registration", "Link to User Registration page").
        setTextLink("User Registration").
        addValidator(new ExpectTextValidator("New Account"))
    ) ;    
    goToPage(path) ;
    addWebUnit(
        new ClickLinkWithText("Management", "Link to User Registration page").
        setTextLink("Management").
        addValidator(new ExpectFormIdValidator("quickSearchForm"))
    ) ;    
    goToPage(path) ;
    addWebUnit(
        new ClickLinkWithText("PortalAdmin", "Link to User Registration page").
        setTextLink("Portal Admin").
        addValidator(new ExpectFormIdValidator("searchForm"))
    ) ;        
    goToPage(path) ;
    addWebUnit(
        new ClickLinkWithText("PortletRegistry", "Link to User Registration page").
        setTextLink("Portlet Registry").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPortletCategories&op=addCategory"))        
    ) ;        
    goToPage(path) ;
    addWebUnit(
        new ClickLinkWithText("Internationalization", "Link to User Registration page").
        setTextLink("Internationalization").
        addValidator(new ExpectTextValidator("Language"))
    ) ;
    goToPage(path) ;
    addWebUnit(
        new ClickLinkWithText("Import/Export", "Link to User Registration page").
        setTextLink("Import/Export").
        addValidator(new ExpectTextValidator(""))
    ) ;
    goToPage(path) ;
    addWebUnit(
        new ClickLinkWithText("Indexing", "Link to User Registration page").
        setTextLink("Indexing").
        addValidator(new ExpectLinkWithURLValidator("&op=reindex&objectId=FileIndexerPlugin"))
    ) ;
    goToPage(path) ;
    addWebUnit(
        new ClickLinkWithText("Monitoring", "Link to User Registration page").
        setTextLink("Monitoring").
        addValidator(new ExpectTextValidator(""))
    ) ;	    
  }  
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }  
}